# Simple vector classes

def div(a, b):
	if b == 0:
		return 0
	return a/b
 
class Vec3:
	def __init__(self, _x, _y, _z):
		self.x = _x
		self.y = _y
		self.z = _z
		
	def __add__(self, a):
		return Vec3(self.x + a.x, self.y + a.y, self.z + a.z)
		
	def __sub__(self, a):
		return Vec3(self.x - a.x, self.y - a.y, self.z - a.z)
		
	def __div__(self, k):
		return Vec3(div(self.x, k), div(self.y, k), div(self.z, k))
		
	def __mult__(self, k):
		return Vec3(self.x * k, self.y * k, self.z * k)
   	
	def __neg__(self):
		return Vec3(-self.x, -self.y, -self.z)
    	
	def __str__(self):
		return "x: " + str(self.x) + "| y: " + str(self.y) + "| z: " + str(self.z)
		
	def copy(self):
		return Vec3(self.x, self.y, self.z)
			
	def inc(self, a):
	    self.x += a.x
	    self.y += a.y
	    self.z += a.z
    
	def dec(self, a):
		self.x -= a.x
		self.y -= a.y	
		self.z -= a.z
		
	def norm(self):
		length = self.length()
		self.x /= length
		self.y /= length
		self.z /= length
		return self
    
	def length(self):
		return sqrt((self.x * self.x) + (self.y * self.y) + (self.z * self.z))
